您的位置:首页 > 其它

LeetCode -- Counting Bits

2016-04-11 10:57 423 查看
Question:

Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1's in their binary representation and return them as an array.

Example:
For
num = 5
you should return
[0,1,1,2,1,2]
.

Follow up:

It is very easy to come up with a solution with run time O(n*sizeof(integer)). But can you do it in linear time O(n) /possibly in a single pass?

Space complexity should be O(n).

Can you do it like a boss? Do it without using any builtin function like __builtin_popcount in c++ or in any other language.

Analysis:

给定一个非负的整数num,对于0 ≤ i ≤ num的每一个i,计算i的二进制位中有多少个1,返回一个记录1的个数的数组。

Follow up:

你能在O(n)的时间内只遍历一遍得到答案嘛?

空间复杂度为O(n).

思路:

因为是计算1的个数,所以肯定跟除2以及除2后的余数有关系了。而且计算时是递增的,因此下一个数字可以利用上一个数字的计算结果。

代码如下:

public class Solution {
public int[] countBits(int num) {
int[] dp = new int[num+1];
dp[0] = 0;
for(int i=1; i<=num; i++) {
int t1 = i / 2;
int t2 = i % 2;
dp[i] = dp[t1] + t2;
}
return dp;
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: